#!/usr/bin/ruby

require 'cgi'
require 'net/http'
require 'uri'
require 'mofo'
require 'timeout'

Mofo.timeout = 30

cgi = CGI.new("html4")

if cgi.params["url"]
    url = cgi.params["url"][0]
elsif cgi.referer
    url = cgi.referer
else
    cgi.out("status" =>  "BAD_REQUEST") { "Error: No Url Parameter! " }
end
url = "http://" + url unless url =~ /^http(s)?:\/\//


begin
    hcards = hCard.find url
rescue Timeout::Error
     cgi.out( "status" =>  "BAD_REQUEST") { "Error: Problems fetching URL! " }
end


def print_prop(prop,value)
    if value.class == [].class
        l = value.map { |v| print_prop(prop,v) }
        return l.join("\n")
    end
    if value.class == Geo
       return "Geo: <a href='http://maps.google.com/maps?q=#{value.latitude},#{value.longitude}' class='geo'>(<span class='latitude'>#{value.latitude}</span>;<span class='longitude'>#{value.longitude}</span>)</a><br />" 
    end
    
    if prop == "fn"
         return "<h2 class='fn'>#{value}</h2>"
    elsif prop == "photo" or prop == "logo"
        return "<img src='#{value}' alt='' class='#{prop}' style='float: right; margin-left: 10px;' />"
    elsif prop == "email"
        return "Email: <a href='mailto:#{value}' class='email'>#{value}</a><br />"
    elsif prop == "url"
        return "URL: <a href='#{value}' rel='me' class='url'>#{value}</a><br />"
    elsif prop == "note"
        return "Note: <blockquote>#{value}</blockquote><br />"
    elsif prop == "n"
        return ""
    elsif prop == "adr"
        l = value.properties.map { |v| 
            v2 = value.send v
            "<span class='#{v}'>#{v2}</span>" }
        return "Address: <span class='adr'>" + l.join(", ")  + "</span>" 
    else
        return prop.to_s.capitalize + ": <span class='"+prop.to_s+"'>"+value.to_s+"</span><br />"
    end
end

def compare(where,what)
    if where.class == [].class
        l = where.map { |v| compare(v,what) }
        l.each do |v|
            if v
                return true
            end
        end
        return false
    else
        if what == nil or where == nil
            return false
        end
        if what[what.length-1] == 47
            what2 = what[0..what.length-1]
        else
            what2 = what
        end
        if where[where.length-1] == 47
            where2 = where[0..where.length-1]
        else
            where2 = where
        end
        return what2 == where2
    end
end


s = ""

if hcards.class != [].class
    hcards = [hcards]
end

hcards.sort { |a,b| a.properties.size <=> b.properties.size }
hcards = hcards.reverse

if hcards.size == 0
   s += "<center>Sorry, no hCards found!</center>" 
end

hcards2 = []

hcards.each do |hcard|
    if hcard.properties.include?("url")
        if compare(hcard.url,url)
            hcards2 << hcard
        end
    end
end

if hcards.size > 0
    if hcards2.empty? or hcards2 == nil
        hcards2 = [hcards.first]
    else
        hcards2 = [hcards2.first]
    end
end

hcards2.each do |hcard|
    s += "<div class='vcard'>"
    
    if hcard.properties.index("fn") != nil
        s += print_prop("fn",hcard.fn)
    end
    if hcard.properties.index("photo") != nil
       s += print_prop("photo",hcard.photo)
    end
    if hcard.properties.index("email") != nil
       s +=  print_prop("email",hcard.email)
    end
    if hcard.properties.index("url") != nil
       s += print_prop("url",hcard.url)
    end
    
    
    already_done = ['fn','url','email','photo']
    rest = hcard.properties
    already_done.each do |tag|
        rest.delete(tag)
    end
    rest.each do |prop|
        v = hcard.send prop
        s += print_prop(prop,v)
    end
    urlp = CGI.escape(url)
    s += "<br /><a href='http://feeds.technorati.com/contacts/#{urlp}'><img src='hCard.png' alt='Download vCard' style='border: 0;' /></a><br /></div>\n"
end

cgi.out do
    cgi.html do
        "<head><meta http-equiv='Content-Type' content='text-html; charset=utf-8' /><title>hParser</title><link href='hCards.css' rel='stylesheet' type='text/css' /></head>" + cgi.body do
            s  
        end
    end
end