#!/usr/bin/ruby

require 'cgi'
require 'net/http'
require 'uri'
require 'mofo'
require 'timeout'

Mofo.timeout = 20

default = "http://junk.ideias3.com/hCard/default.png"
email = ""
url = ""


class CGI
  def redirect(url)
    print self.header({'status' => '302', 'location' => url})
    exit(0)
  end
end

def gravatar(email,default)
    #require 'digest/md5'
    #digest = Digest::MD5.hexdigest(email)
    return "http://www.gravatar.com/avatar.php?gravatar_id=#{email}&default=#{default}"
end


cgi = CGI.new()

if cgi.params["default"]
    default = cgi.params["default"][0] unless cgi.params["default"][0].nil?
    default = "http://" + default unless default =~ /^http(s)?:\/\//
end

if cgi.params["email"]
    email = cgi.params["email"][0] unless cgi.params["email"][0].nil?
end

if cgi.params["url"]
    url = cgi.params["url"][0] unless cgi.params["url"][0].nil?
    url = "http://" + url unless url =~ /^http(s)?:\/\//
end


if url == ""
  if email == ""
    cgi.redirect(default)
  else
    cgi.redirect(gravatar(email,default))
  end
end

begin
    hcards = hCard.find url
rescue Timeout::Error
  if email == ""
    cgi.redirect(default)
  else
    cgi.redirect(gravatar(email,default))
  end
end

def compare(where,what)
    if where.class == [].class
        l = where.map { |v| compare(v,what) }
        l.each do |v|
            if v
                return true
            end
        end
        return false
    else
        if what == nil or where == nil
            return false
        end
        if what[what.length-1] == 47
            what2 = what[0..what.length-1]
        else
            what2 = what
        end
        if where[where.length-1] == 47
            where2 = where[0..where.length-1]
        else
            where2 = where
        end
        return what2 == where2
    end
end



if hcards.class != [].class
    hcards = [hcards]
end

hcards.sort { |a,b| a.properties.size <=> b.properties.size }
hcards = hcards.reverse

if hcards.size > 0

    hcards2 = []

    hcards.each do |hcard|
      if hcard.properties.include?("url")
          if compare(hcard.url,url)
              hcards2 << hcard
          end
      end
    end

    if hcards.size > 0
      if hcards2.empty? or hcards2 == nil
          hcards2 = [hcards.first]
      else
          hcards2 = [hcards2.first]
      end
    end

    hcards2 = hcards2 + hcards

    hcards2.each do |hcard|
      if hcard.properties.include?("photo")
          cgi.redirect(hcard.photo)
      end
    end
end


# fallback


if email == ""
  cgi.redirect(default)
else
  cgi.redirect(gravatar(email,default))
end
